#include "aib.h"
#include "extern.h"

/* prototypes */
void menu_menu(void);
void project_menu(void);

extern BOOL fchecked;

/***************************** menu menu *******************************/
void menu_menu(void)
{
   UWORD top;              /* offset into Window under titlebar */
   struct NewGadget ng;    /* for Gadget positioning */
   struct Gadget *gad;     /* our running Gadget pointer */
   struct Node *node;
   struct title_box *indt = topt;

   top = window->BorderTop + 1;
   gad =  CreateContext(&glist);

   /* setup lists */
  NewList(&tit_list);
    while(indt)
     {
      node=(struct Node *)AllocRemember(&rmem,sizeof(struct Node), MEMF_CLEAR);
      if (!node)
          abort_me("couldn't allocate LISTVIEW list.");
      node->ln_Name = indt->title;
      AddTail(&tit_list,node);
      indt = indt->next;
     }    

   ng.ng_TextAttr = &topaz80;
   ng.ng_VisualInfo = vi;
   ng.ng_Flags = 0;

	ng.ng_Width = 160;
	ng.ng_Height = 14;
	ng.ng_GadgetText = NULL;
	ng.ng_GadgetID = MM_tstring;
	 tstring= gad = CreateGadget(STRING_KIND,gad,&ng,
		GTST_MaxChars,256,
	        GA_Disabled,TRUE,
		TAG_DONE);

        ng.ng_LeftEdge = 15;
        ng.ng_TopEdge = top + 15;
        ng.ng_Width = 160;
        ng.ng_Height = 60;
        ng.ng_GadgetID = MM_titl;
	ng.ng_GadgetText="Titles";
         tl= gad = CreateGadget(LISTVIEW_KIND,gad,&ng,
	    GTLV_Labels,&tit_list,
	    GTLV_ShowSelected,gad,
	    LAYOUTA_SPACING,2,
            GT_Underscore, '*',
            TAG_DONE);

	ng.ng_Width = 160;
	ng.ng_Height = 14;
	ng.ng_GadgetText = NULL;
	ng.ng_GadgetID = MM_istring;
	 istring= gad = CreateGadget(STRING_KIND,gad,&ng,
		GTST_MaxChars,256,
		GA_Disabled,TRUE,
		TAG_DONE);

        ng.ng_LeftEdge = 194;
        ng.ng_TopEdge = top + 15;
        ng.ng_Width = 160;
        ng.ng_Height = 60;
        ng.ng_GadgetID = MM_item;
	ng.ng_GadgetText="Items";
          il=gad = CreateGadget(LISTVIEW_KIND,gad,&ng,
	    GTLV_ShowSelected,gad,
	    LAYOUTA_SPACING,2,
	    GA_Disabled,FALSE,
            GT_Underscore, '*',
            TAG_DONE);

	ng.ng_Width = 160;
	ng.ng_Height = 14;
	ng.ng_GadgetText = NULL;
	ng.ng_GadgetID = MM_sstring;
	 sstring= gad = CreateGadget(STRING_KIND,gad,&ng,
		GTST_MaxChars,256,
		GA_Disabled,TRUE,
		TAG_DONE);

        ng.ng_LeftEdge = 373;
        ng.ng_TopEdge = top + 15;
        ng.ng_Width = 160;
        ng.ng_Height = 60;
        ng.ng_GadgetID = MM_subs;
	ng.ng_GadgetText="Submenus";
         sl = gad = CreateGadget(LISTVIEW_KIND,gad,&ng,
	    GTLV_ShowSelected,gad,
	    LAYOUTA_SPACING,2,
	    GA_Disabled,FALSE,
            GT_Underscore, '*',
            TAG_DONE);


   ng.ng_LeftEdge = 15;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_ta;
   ng.ng_GadgetText="ADD";
   ta= gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled , FALSE,
          TAG_DONE);

   ng.ng_LeftEdge = 70;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 50;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_td;
   ng.ng_GadgetText="DEL";
    td=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 120;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_ts;
   ng.ng_GadgetText="SWAP";
    ts=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 194;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_ia;
   ng.ng_GadgetText="ADD";
    ia=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 249;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 50;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_id;
   ng.ng_GadgetText="DEL";
    id=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 299;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_is;
   ng.ng_GadgetText="SWAP";
    is=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 373;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_sa;
   ng.ng_GadgetText="ADD";
    sa=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 428;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 50;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_sd;
   ng.ng_GadgetText="DEL";
    sd=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 478;
   ng.ng_TopEdge = top + 73; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_ss;
   ng.ng_GadgetText="SWAP";
    ss=gad = CreateGadget(BUTTON_KIND,gad,&ng,
	  GA_Disabled,TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 170;
   ng.ng_TopEdge = top + 110; 
   ng.ng_Width = 75;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_tog;
   ng.ng_GadgetText="Type";
    tog=gad = CreateGadget(CYCLE_KIND,gad,&ng,
	  GA_Disabled,TRUE,
	  GTCY_Labels,MFlags,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 85;
   ng.ng_TopEdge = top + 110; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_chec;
   ng.ng_GadgetText="Checked";
    chec=gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
	  GA_Disabled,TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 210;
   ng.ng_TopEdge = top + 90; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_bar;
   ng.ng_GadgetText="menu bar?";
    bar=gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
	  GA_Disabled,TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 338;
   ng.ng_TopEdge = top + 88; 
   ng.ng_Width = 25;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_select;
   ng.ng_GadgetText="Choice:";
    select=gad = CreateGadget(TEXT_KIND,gad,&ng,
	  GTTX_Border,TRUE,
	  GTTX_Text,select_type,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 373;
   ng.ng_TopEdge = top + 88; 
   ng.ng_Width = 160;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_stype;
   ng.ng_GadgetText="";
    stype=gad = CreateGadget(TEXT_KIND,gad,&ng,
	  GTTX_Border,TRUE,
	  GTTX_Text,name_type,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 375;
   ng.ng_TopEdge = top + 108; 
   ng.ng_Width = 160;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_func;
   ng.ng_GadgetText="Function Name";
    func=gad = CreateGadget(STRING_KIND,gad,&ng,
	  GA_Disabled,TRUE,
	  GTST_MaxChars,50,
	  GTST_String,"",
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 90;
   ng.ng_TopEdge = top + 90; 
   ng.ng_Width = 55;
   ng.ng_Height = 12;
   ng.ng_GadgetID = MM_dis;
   ng.ng_GadgetText="Disabled";
    dis=gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 30;
   ng.ng_TopEdge = top + 132; 
   ng.ng_Width = 10;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_fche;
   ng.ng_GadgetText="";
    fche=gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
	  GTCB_Checked,fchecked,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 130;
   ng.ng_TopEdge = top + 130; 
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_font;
   ng.ng_GadgetText="Custom:";
    menu_font = gad = CreateGadget(TEXT_KIND,gad,&ng,
	  GA_Disabled,TRUE,
	  GTTX_Text,menucta.ta_Name,
	  GTTX_Border,TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 290;
   ng.ng_TopEdge = top + 130; 
   ng.ng_Width = 35;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_sfont;
   ng.ng_GadgetText=NULL;
    menu_size = gad = CreateGadget(NUMBER_KIND,gad,&ng,
	  GTNM_Number,menucta.ta_YSize,
	  GTNM_Border,TRUE,
	  GA_Disabled,TRUE,
          GT_Underscore, '*',
          TAG_DONE);
    
   ng.ng_LeftEdge = 360;
   ng.ng_TopEdge = top + 130;
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_nfont;
   ng.ng_GadgetText="Choose Font...";
    nfont=gad = CreateGadget(BUTTON_KIND,gad,&ng,
	  GA_Disabled,(fchecked)?FALSE:TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 260;
   ng.ng_TopEdge = top + 150;
   ng.ng_Width = 30;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_key;
   ng.ng_GadgetText="HotKey:";
    key=gad = CreateGadget(STRING_KIND,gad,&ng,
	  GTST_MaxChars,1,
	  GTST_String,"",	  
	  GA_Disabled,TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 360;
   ng.ng_TopEdge = top + 160;
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_can;
   ng.ng_GadgetText="*Cancel";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 30;
   ng.ng_TopEdge = top + 160;
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = MM_ok;
   ng.ng_GadgetText="*OK";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
          TAG_DONE);

 
    if (!gad)
      abort_me("Couldn't allocate the Gadget list.");

   AddGList(window, glist, (UWORD)-1, (UWORD)-1, NULL);
   RefreshGList(glist, window, NULL, (UWORD)-1);
   GT_RefreshWindow(window, NULL);
}


/*********************** project menu **************************************/

void project_menu(void)
{
   UWORD top;              /* offset into Window under titlebar */
   struct NewGadget ng;    /* for Gadget positioning */
   struct Gadget *gad;     /* our running Gadget pointer */
   
   top = window->BorderTop + 1;
   gad =  CreateContext(&glist);

   ng.ng_TextAttr = &topaz80;
   ng.ng_VisualInfo = vi;

   ng.ng_Flags=PLACETEXT_LEFT;
   ng.ng_LeftEdge = 195;
   ng.ng_TopEdge = top + 10;
   ng.ng_Width = 170;
   ng.ng_Height = 15;
   ng.ng_GadgetID = P_name;
   ng.ng_GadgetText = "Project Name:";
    gad = CreateGadget(TEXT_KIND,gad,&ng,
	  GTTX_Border,TRUE,
	  GTTX_Text,"none",
          GT_Underscore,'_',
          TAG_DONE);
    
   ng.ng_Flags=0;  
   ng.ng_LeftEdge = 65;
   ng.ng_TopEdge = top + 55;
   ng.ng_Width = 170;
   ng.ng_Height = 20;
   ng.ng_GadgetID = P_load;
   ng.ng_GadgetText = "Load Project...";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore,'_',
          TAG_DONE);

   ng.ng_LeftEdge = 65;
   ng.ng_TopEdge = top + 95;
   ng.ng_Width = 170;
   ng.ng_Height = 20;
   ng.ng_GadgetID= P_save;
   ng.ng_GadgetText=  "Save Project";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore,'_',
          TAG_DONE);
   
   ng.ng_LeftEdge = 65;
   ng.ng_TopEdge = top + 135;
   ng.ng_Width = 170;
   ng.ng_Height = 20;
   ng.ng_GadgetID= P_saveas;
   ng.ng_GadgetText=  "Save Project AS...";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore,'_',
          TAG_DONE);       
          
   ng.ng_LeftEdge = window->Width-240;
   ng.ng_TopEdge = top + 55;
   ng.ng_Width = 170;
   ng.ng_Height = 20;
   ng.ng_GadgetID= P_savec;
   ng.ng_GadgetText=  "Save C";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore,'_',
          TAG_DONE);
   
   ng.ng_LeftEdge = window->Width-240;
   ng.ng_TopEdge = top + 95;
   ng.ng_Width = 170;
   ng.ng_Height = 20;
   ng.ng_GadgetID= P_saveasc;
   ng.ng_GadgetText=  "Save C AS...";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore,'_',
          TAG_DONE);
   
   ng.ng_LeftEdge = window->Width-240;
   ng.ng_TopEdge = top + 135;
   ng.ng_Width = 170;
   ng.ng_Height = 20;
   ng.ng_GadgetID= P_can;
   ng.ng_GadgetText=  "Cancel";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore,'_',
          TAG_DONE);
      
    if (!gad)
      abort_me("Couldn't allocate the Gadget list.");

   AddGList(window, glist, (UWORD)-1, (UWORD)-1, NULL);
   RefreshGList(glist, window, NULL, (UWORD)-1);
   GT_RefreshWindow(window, NULL);
}
